import numpy as np
import matplotlib.pyplot as plt

class SubSer3CatFix():
    def __init__(self, series_v=None, start_s=None, cond=None, ser_id=None):
        self.series = series_v
        self.n = len(self.series)
        self.s = start_s
        self.cond = cond
        self.ser_id = ser_id

    def st_v(self):
        return self.series[self.s]
    
    def next_state(self, response):
        if response <= 1:
            self.s += 1
            if self.s >= self.n:
                self.s = self.n - 1
            self.cond = 'up'
        elif response >= 3:
            self.s -= 1
            if self.s < 0:
                self.s = 0
            self.cond = 'down'
        else:
            if self.cond == 'up':
                self.s += 1
                if self.s >= self.n:
                    self.s = self.n - 1
            else:
                self.s -= 1
                if self.s < 0:
                    self.s = 0
            
ser = ['A']*2 + ['B']*2
 
fout_nm = input('出力ファイル名(.txt) = ')
fout = open(fout_nm, 'w')

while True:
    series = input('刺激系列（小ー＞大）= ').split()
    print('入力系列 =')
    print(series)
    for i, v in enumerate(series):
        print(f'{i+1}: {v}')
    #for v in series:
    #    print(v)
    ck = input('OK(y/n) = ')
    if ck in ['y', 'Y']:
        break
        
N_blocks = int(input('ブロック数（１ブロック=４試行）= '))

data = []

serA = SubSer3CatFix( series_v=[float(v) for v in series], start_s=len(series)-1, cond='down', ser_id='A')
serB = SubSer3CatFix( series_v=[float(v) for v in series], start_s=0, cond='up', ser_id='B')

t = 0
for b in range(N_blocks):
    np.random.shuffle(ser)
    for i in range(4):
        t += 1
        print('\n試行：{0:}/{1:}'.format(t, N_blocks*4))
        if ser[i] == 'A':
            serX = serA
        else:
            serX = serB
            
        print('刺激値：', serX.st_v())
        res = int(input("\n反応(1:小・弱, 2:不明・等しい, 3:大・強)? "))
        data.append([f'{serX.ser_id}{t}', serX.st_v(), res])
        serX.next_state(res)
            
print('{0:>15}{1:>15}{2:>15}'.format('trial', 'stimulus', 'response'))
fout.write('{0:>15}{1:>15}{2:>15}'.format('trial', 'stimulus', 'response'))

for i, v in enumerate(data):
    print('{0:>15}{1:>15}{2:>15}'.format(v[0], v[1], v[2]))
    fout.write('\n{0:>15}{1:>15}{2:>15}'.format(v[0], v[1], v[2]))
    plt.plot([i], [v[1]],'^' if v[2] == 3 else 'v' if v[2] == 1 else'o',
             c = 'b' if v[0][0] == 'A' else 'g')

plt.plot([], 's', c = 'b', label = 'Ser.A')
plt.plot([], 's', c = 'g', label = 'Ser.B')
plt.plot([], '^', c = 'k', label = '3')
plt.plot([], 'o', c = 'k', label = '2')
plt.plot([], 'v', c = 'k', label = '1')
plt.xlabel('Trial')
plt.ylabel('Comp. St.')
plt.title('Up-down Method')
plt.legend()
plt.savefig('Fig' + fout_nm[:-4] + '.png')
plt.show()

print('\nFig' + fout_nm[:-4] + '.png was saved.')
fout.close()
print(fout_nm + '.was saved.\n')
